//+------------------------------------------------------------------+
//|                                                         myea.mq4 |
//|                                           Copyright  2011 by me |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011"
#property link      ""
#include <stdlib.mqh>
#include <stderror.mqh>

#define major   1
#define minor   0


extern int        Magic = 3;
extern double     Lots = 0.1;
extern int        Slippage = 3;
extern int        SL = 60;
extern int        TP = 21;

extern int        START = 0;
extern int        END = 7;
extern int        TrailingStop=15;
extern int        TrailingShag=2;
int               CandelCount = 5;
int               Max = 12;
int               Min = 8;
int               HIDETP = 20;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init () {
}

void deinit() {
}

void start() {
   double ld_44;
   double ld_52;
   double l_high_60;
   double l_low_68;
   double ld_76;
   double l_high_84;
   double l_low_92;
   double ld_100;
   double l_high_108;
   double l_low_116;
   double ld_124;
   double l_high_132;
   double l_low_140;
   double   digit; digit=MarketInfo(Symbol(),MODE_DIGITS);
   
   


  if (!IsTesting()) Comment("Version: ", major, ".", minor);
  
   
   //masukkan indikator atau apa saja yang akan dijadikan logika

      l_high_84 = High[iHighest(Symbol(), Period(), MODE_HIGH, CandelCount, 1)];
      l_low_92 = Low[iLowest(Symbol(), Period(), MODE_LOW, CandelCount, 1)];
      
      l_high_108 = High[iHighest(Symbol(), Period(), MODE_CLOSE, CandelCount, 1)];
      l_low_116 = Low[iLowest(Symbol(), Period(), MODE_OPEN, CandelCount, 1)];
      
      l_high_132 = High[iLowest(Symbol(), Period(), MODE_CLOSE, CandelCount, 1)];
      l_low_140 = Low[iHighest(Symbol(), Period(), MODE_OPEN, CandelCount, 1)];
      
      ld_76 = l_high_84 - l_low_92;// ld_76 = high-low
      ld_100 = l_high_108 - l_low_116; //ld_100 = high-low
      ld_124 = l_low_140 - l_high_132; //ld_124 = low-high
      
      //jika ld_124/Point lebihkecil= 220 & ld_124/Point lebihbesar= 80
      //
      if (ld_124 / Point <= Max && ld_124 / Point >= Min) {
         l_high_60 = l_high_84;
         l_low_68 = l_low_92;
         ld_52 = ld_76;
      }



  int BuyCnt = 0;
  int SellCnt = 0;
  
  int cnt = OrdersTotal();
  for (int i = 1; i < cnt; i++) 
  
  //for (int i = OrdersTotal() - 1; i >= 0; i--)
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    
    int type = OrderType();
    if (type == OP_BUY) BuyCnt++;
    if (type == OP_SELL) SellCnt++;
  }
   



  double price,sl,tp;

/////// nah disini tempatnya memasukkan logika EAnya
// contoh = jika close kemaren lebih close sekarang maka BUY atau bisa juga SELL  




if (Hour()>START && Hour()<END) 
{

///////////////////// BUY AREA//////////////////////////////
    
   //if (Close[3]>Close[2]&&Close[2]<=Close[1])
   if (Close[0] < l_low_68 && Open[0] > l_low_68)
///////yang ini ga usah di utak-atik jika belum mengerti
   {

    //CloseOrders(OP_SELL);

    if (BuyCnt == 0) {    
      price = Ask;
      sl = 0;
      tp = 0;

      Buy(Symbol(), Lots, price, Slippage, Bid+SL*Point, Bid-TP*Point, 0);
    }
  }
  
  
///////////////////// SELL AREA //////////////////////////////
  
 if (Close[0] > l_high_60 && Open[0] < l_high_60)
  //if (Close[3]<Close[2]&&Close[2]>=Close[1])
  
  
  
///////yang ini ga usah di utak-atik jika belum mengerti
  {
    //CloseOrders(OP_BUY);

    if (SellCnt == 0) {    
      price = Bid;
      sl = 0;
      tp = 0;
      
      Sell(Symbol(), Lots, price, Slippage, Ask-SL*Point, Ask+TP*Point, 0);
    }
  } 
}
///////////////////// TRAILING /////////////////////////////
   for(cnt=0;cnt<OrdersTotal();cnt++) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);            
      if(OrderType()==OP_BUY) 
      {
      if(TrailingStop>0) 
      {
         if(Bid-OrderOpenPrice()>=TrailingStop*Point && TrailingStop>0 && (Bid-Point*TrailingStop)>OrderStopLoss())
          {
           if(((Bid-Point*TrailingStop)-OrderStopLoss())>=TrailingShag*Point)
           {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Yellow);
               return(0);            
               }
            }
         }
       }
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);            
      if(OrderType()==OP_SELL)
      {   
      if(TrailingStop>0) 
      {
         if(OrderOpenPrice()-Ask>=TrailingStop*Point && TrailingStop>0 && OrderStopLoss()>(Ask+TrailingStop*Point))
          {
           if((OrderStopLoss()-(Ask+TrailingStop*Point))>TrailingShag*Point)
           {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,White);
               return(0);            
               }
            }
         }      
      }

if (Hour()==END)
  {
   CloseOrders(OP_BUY);
   CloseOrders(OP_SELL);
  }
/*  
if ((Bid-HIDETP*Point)>OrderOpenPrice())
   {
   if (Bid>TrailingStop)
      {
      CloseOrders(OP_BUY);
      }
   }
if ((Ask+HIDETP*Point)<OrderOpenPrice())
   {
   if (Bid<TrailingStop)
      {
      CloseOrders(OP_SELL);
      }
   }*/
}

}




void CloseOrders(int type) {

  int cnt = OrdersTotal();
  for (int i=cnt-1; i>=0; i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    
    int type2 = OrderType();
    if (type != type2) continue;
    
    if (type == OP_BUY) CloseOrder(OrderTicket(), OrderLots(), Bid, Slippage);
    if (type == OP_SELL) CloseOrder(OrderTicket(), OrderLots(), Ask, Slippage);
  }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 2000;
int SleepErr = 6000;

int Buy(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") {
  RefreshRates();  
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, 1);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);
  int res = OrderSend(symbol, OP_BUY, lot, price, slip, Ask-SL*Point, Ask+TP*Point, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int Sell(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") {
  RefreshRates();  
  int dig = MarketInfo(symbol, MODE_DIGITS);
  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  string _lot = DoubleToStr(lot, 1);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);
  int res = OrderSend(symbol, OP_SELL, lot, price, slip, Bid+SL*Point, Bid-TP*Point, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
  int code = GetLastError();
  Print("Error opening SELL order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price, int slip) {
  RefreshRates();  
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);
  string _lot = DoubleToStr(lot, 1);
  string _price = DoubleToStr(price, dig);
  bool res = OrderClose(ticket, lot, price, slip);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}




